#
# spec file for package libplist
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           libplist
Version:        1.12
Release:        11.1
Summary:        Library for handling Apple Binary and XML Property Lists
License:        GPL-2.0 and LGPL-2.1+
Group:          System/Libraries
Url:            http://cgit.sukimashita.com/libplist.git
Source:         http://www.libimobiledevice.org/downloads/%{name}-%{version}.tar.bz2
Source99:       baselibs.conf
Patch1:         0001-Fix-possible-crash-in-plist_from_bin-caused-by-access-to-already-freed-memory.patch
Patch2:         0002-Plug-memory-leaks-caused-by-unused-and-unfreed-buffer.patch
Patch3:         0003-Refactor-binary-plist-parsing-in-a-recursive-way.patch
Patch4:         0004-Make-sure-to-compare-the-node-sizes-for-integer-nodes.patch
Patch5:         0005-Change-internal-storage-of-PLIST_DATE-values-from-struct-timeval-to-double.patch
Patch6:         0006-Fix-possible-out-of-bounds-read-in-parse_dict_node-with-proper-bounds-checking.patch
Patch7:         0007-Fix-possible-out-of-bounds-reads-in-parse_bin_node.patch
Patch8:         0008-Make-sure-the-index-in-parse_bin_node_at_index-is-actually-within-the-offset-table.patch
Patch9:         0009-Prevent-out-of-bounds-read-in-plist_from_bin-when-parsing-offset_table.patch
Patch10:        0010-Make-sure-to-error-out-if-allocation-of-used_indexes-buffer-in-plist_from_bin-fails.patch
Patch11:        0011-Disallow-key-nodes-with-non-string-node-types.patch
Patch12:        0012-Prevent-OOB-heap-buffer-read-by-checking-input-size.patch
Patch13:        0013-Improve-UINT_TO_HOST-macro-remove-uint24_from_be-function.patch
Patch14:        0014-Check-for-invalid-offset_size-in-bplist-trailer.patch
Patch15:        0015-Use-proper-struct-for-binary-plist-trailer.patch
Patch16:        0016-Mass-rename-dict_size-and-param_dict_size-to-more-appropiate-ref_size.patch
Patch17:        0017-Fix-possible-out-of-bounds-read-in-parse_array_node-with-proper-bounds-checking.patch
Patch18:        0018-Avoid-heap-buffer-allocation-when-parsing-array-dict-string-data-node-sizes-14.patch
Patch19:        0019-Unify-size-node-parsing-for-data-string-array-dict-nodes.patch
Patch20:        0020-Prevent-OOB-read-when-parsing-data-string-array-dict-size-nodes.patch
Patch21:        0021-Fix-OOB-write-on-heap-buffer-and-improve-recursion-check.patch
Patch22:        0022-Make-sure-node-index-is-smaller-than-number-of-objects.patch
Patch23:        0023-Make-sure-the-offset-table-is-in-the-correct-range.patch
Patch24:        0024-Plug-memory-leak-in-case-parsing-a-dictionary-key-fails.patch
Patch26:        0026-bplist-Improve-real-date-node-de-serialization.patch
Patch27:        0027-bplist-Improve-parsing-unicode-nodes.patch
# PATCH-FIX-UPSTREAM 0029-bplist-Make-sure-to-bail-out-if-malloc-fails-in-pars.patch boo#1029639 alarrosa@suse.com -- make sure to bail out if malloc fails in parse_string_node (CVE-2017-6435).
Patch29:        0029-bplist-Make-sure-to-bail-out-if-malloc-fails-in-pars.patch
Patch30:        0030-bplist-Make-sure-to-bail-out-if-malloc-fails-in-pars.patch
Patch31:        0031-bplist-Make-sure-to-bail-out-if-malloc-fails-in-pars.patch
Patch32:        0032-bplist-Properly-handle-some-more-malloc-failure-situ.patch
Patch33:        0033-plist-Fix-assert-to-allow-16-or-8-byte-integer-sizes.patch
Patch34:        C0001-Plug-memory-leak-when-converting-PLIST_UID-nodes-to-XML.patch
Patch35:        C0002-Improve-writing-of-array-and-dictionary-nodes.patch
Patch36:        C0003-Improve-writing-of-integer-nodes.patch
Patch37:        C0004-Fix-UID-node-parsing-to-match-Apples-parser.patch
Patch38:        C0005-Improve-writing-of-UID-nodes.patch
Patch39:        C0006-Improve-writing-of-data-string-and-unicode-nodes.patch
Patch40:        C0007-Improve-writing-of-offset-table.patch
#PATCH-FIX-UPSTREAM Nikias Bassen <nikias@gmx.li> CVE-2017-5209
#rework base64decode to handle split encoded data
Patch101:       B0005-base64-Prevent-buffer-overflow-by-not-decoding-blocks-with-less-than-4-chrs.patch
Patch102:       B0006-Prevent-use-strlen-in-base64decode-when-input-buffer-size-is-known.patch
Patch103:       B0007-base64-Rework-base64decode-to-handle-split-encoded-data.patch
# PATCH-FIX-UPSTREAM libplist-boo1035312-overflow-fixes.patch boo#1035312 mgorse@suse.com -- add some overflow checks (boo#1035312 CVE-2017-7982).
Patch110:       libplist-boo1035312-overflow-fixes.patch
# PATCH-FIX-UPSTREAM libplist-boo1029631-32bit.patch boo#1029631 boo#1029638 boo#1029706 boo#1029751 mgorse@suse.com -- make sure sanity checks work on 32-bit platforms, and fix range checks (CVE-2017-6440 CVE-2017-6439 CVE-2017-6438 CVE-2017-6436).
Patch111:       libplist-boo1029631-32bit.patch
# PATCh-FIX-UPSTREAM libplist-boo1029707-base64-invalid-read.patch boo#1029707 mgorse@suse.com -- prevent undefined shift when parsing invalid base64 encoded data (CVE-2017-6437).
Patch112: libplist-boo1029707-base64-invalid-read.patch

BuildRequires:  gcc-c++
BuildRequires:  libxml2-devel >= 2.7.8
BuildRequires:  pkg-config
BuildRequires:  python-cython
BuildRequires:  python-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
libplist is a library for handling Apple Binary and XML Property Lists.

%package -n libplist3
Summary:        Library for handling Apple Binary and XML Property Lists
Group:          System/Libraries
Provides:       libplist = %{version}
Obsoletes:      libplist < %{version}

%description -n libplist3
libplist is a library for handling Apple Binary and XML Property Lists.

%package -n libplist++3
Summary:        Library for handling Apple Binary and XML Property Lists
Group:          System/Libraries
Provides:       libplist++ = %{version}
Obsoletes:      libplist++ < %{version}

%description -n libplist++3
libplist is a library for handling Apple Binary and XML Property Lists.

%package -n plistutil
Summary:        Library for handling Apple Binary and XML Property Lists
Group:          System/Libraries
Requires:       libplist = %{version}
Provides:       plutil = %{version}
Obsoletes:      plutil < %{version}

%description -n plistutil
libplist is a library for handling Apple Binary and XML Property Lists.

This package contains an utility to convert PList files from binary to XML and
from XML to binary.

%package devel
Summary:        Library for handling Apple Binary and XML Property Lists -- Development Files
Group:          Development/Libraries/C and C++
Requires:       libplist = %{version}

%description devel
libplist is a library for handling Apple Binary and XML Property Lists.

This package contains the development files for C.

%package -n libplist++-devel
Summary:        Library for handling Apple Binary and XML Property Lists -- Development Files
Group:          Development/Libraries/C and C++
Requires:       libplist++ = %{version}
Requires:       libplist-devel

%description -n libplist++-devel
libplist is a library for handling Apple Binary and XML Property Lists.

This package contains the development files for C++.

%package -n python-plist
Summary:        Library for handling Apple Binary and XML Property Lists -- Python Bindings
Group:          Development/Languages/Python
Requires:       libplist3 = %{version}
Requires:       python-cython >= 0.13

%description -n python-plist
libplist is a library for handling Apple Binary and XML Property Lists.

This package contains the python bindings.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch26 -p1
%patch27 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1

%build
%configure --disable-static
make %{?_smp_mflags}

%check
TZ=Europe/Vienna make check VERBOSE=1

%install
make DESTDIR=%{buildroot} install %{?_smp_mflags}
find %{buildroot} -type f -name "*.la" -delete -print
rm -rf %{buildroot}%{python_sitearch}/*.la

# needed by python-imobiledevice build
mkdir -p %{buildroot}%{_includedir}/plist/cython
install -m 0644 cython/plist.pxd %{buildroot}%{_includedir}/plist/cython/plist.pxd

%if 0%{?_crossbuild}
cp -a %{buildroot}%{?_sysroot}/* %{buildroot}/
rm -fr %{buildroot}%{?_sysroot}
%endif

%post -n libplist3 -p /sbin/ldconfig

%postun -n libplist3 -p /sbin/ldconfig

%post -n libplist++3 -p /sbin/ldconfig

%postun -n libplist++3 -p /sbin/ldconfig

%files -n libplist3
%defattr(-,root,root)
%doc AUTHORS COPYING COPYING.LESSER README NEWS
%{_libdir}/libplist.so.*

%files -n libplist++3
%defattr(-,root,root)
%doc AUTHORS COPYING COPYING.LESSER README NEWS
%{_libdir}/libplist++.so.*

%files -n plistutil
%defattr(-,root,root)
%{_bindir}/plistutil

%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/plist
%{_includedir}/plist/plist.h
%{_libdir}/libplist.so
%{_libdir}/pkgconfig/libplist.pc

%files -n libplist++-devel
%defattr(-,root,root,-)
%dir %{_includedir}/plist
%{_includedir}/plist/plist++.h
%{_includedir}/plist/Array.h
%{_includedir}/plist/Boolean.h
%{_includedir}/plist/Data.h
%{_includedir}/plist/Date.h
%{_includedir}/plist/Dictionary.h
%{_includedir}/plist/Integer.h
%{_includedir}/plist/Key.h
%{_includedir}/plist/Uid.h
%{_includedir}/plist/Node.h
%{_includedir}/plist/Real.h
%{_includedir}/plist/String.h
%{_includedir}/plist/Structure.h
%{_libdir}/libplist++.so
%{_libdir}/pkgconfig/libplist++.pc

%files -n python-plist
%defattr(-,root,root,-)
%dir %{_includedir}/plist/cython
%{_includedir}/plist/cython/plist.pxd
%{python_sitearch}/plist.so

%changelog
* Tue Jul 25 2017 mgorse@suse.com
- Add libplist-boo1029707-base64-invalid-read.patch: prevent
  undefined shift when parsing invalid base64 encoded data
  (boo#1029707 CVE-2017-6437).
* Wed May  3 2017 mgorse@suse.com
- Add libplist-boo1035312-overflow-fixes.patch: add some safety
  checks, backported from upstream (boo#1035312 CVE-2017-7982).
- Add libplist-boo1029631-32bit.patch: ensure that sanity checks
  work on 32-bit platforms, and fix data range checks (boo#1029631
  boo#1029638 boo#1029706 boo#1029751 CVE-2017-6440 CVE-2017-6439
  CVE-2017-6438 CVE-2017-6436).
* Tue Feb  7 2017 alarrosa@suse.com
- Add patches from upstream to fix a multitude of memory leaks,
  out of bound reads and writes and check index ranges:
  0001-Fix-possible-crash-in-plist_from_bin-caused-by-access-to-already-freed-memory.patch
  0002-Plug-memory-leaks-caused-by-unused-and-unfreed-buffer.patch
  0003-Refactor-binary-plist-parsing-in-a-recursive-way.patch
  0004-Make-sure-to-compare-the-node-sizes-for-integer-nodes.patch
  0005-Change-internal-storage-of-PLIST_DATE-values-from-struct-timeval-to-double.patch
  0006-Fix-possible-out-of-bounds-read-in-parse_dict_node-with-proper-bounds-checking.patch
  0007-Fix-possible-out-of-bounds-reads-in-parse_bin_node.patch
  0008-Make-sure-the-index-in-parse_bin_node_at_index-is-actually-within-the-offset-table.patch
  0009-Prevent-out-of-bounds-read-in-plist_from_bin-when-parsing-offset_table.patch
  0010-Make-sure-to-error-out-if-allocation-of-used_indexes-buffer-in-plist_from_bin-fails.patch
  0011-Disallow-key-nodes-with-non-string-node-types.patch
  0012-Prevent-OOB-heap-buffer-read-by-checking-input-size.patch
  0013-Improve-UINT_TO_HOST-macro-remove-uint24_from_be-function.patch
  0014-Check-for-invalid-offset_size-in-bplist-trailer.patch
  0015-Use-proper-struct-for-binary-plist-trailer.patch
  0016-Mass-rename-dict_size-and-param_dict_size-to-more-appropiate-ref_size.patch
  0017-Fix-possible-out-of-bounds-read-in-parse_array_node-with-proper-bounds-checking.patch
  0018-Avoid-heap-buffer-allocation-when-parsing-array-dict-string-data-node-sizes-14.patch
  0019-Unify-size-node-parsing-for-data-string-array-dict-nodes.patch
  0020-Prevent-OOB-read-when-parsing-data-string-array-dict-size-nodes.patch
  0021-Fix-OOB-write-on-heap-buffer-and-improve-recursion-check.patch
  0022-Make-sure-node-index-is-smaller-than-number-of-objects.patch
  0023-Make-sure-the-offset-table-is-in-the-correct-range.patch
  0024-Plug-memory-leak-in-case-parsing-a-dictionary-key-fails.patch
  0026-bplist-Improve-real-date-node-de-serialization.patch
  0027-bplist-Improve-parsing-unicode-nodes.patch
  0029-bplist-Make-sure-to-bail-out-if-malloc-fails-in-pars.patch
  (boo#1029639 CVE-2017-6435)
  0030-bplist-Make-sure-to-bail-out-if-malloc-fails-in-pars.patch
  0031-bplist-Make-sure-to-bail-out-if-malloc-fails-in-pars.patch
  0032-bplist-Properly-handle-some-more-malloc-failure-situ.patch
  0033-plist-Fix-assert-to-allow-16-or-8-byte-integer-sizes.patch
  C0001-Plug-memory-leak-when-converting-PLIST_UID-nodes-to-XML.patch
  C0002-Improve-writing-of-array-and-dictionary-nodes.patch
  C0003-Improve-writing-of-integer-nodes.patch
  C0004-Fix-UID-node-parsing-to-match-Apples-parser.patch
  C0005-Improve-writing-of-UID-nodes.patch
  C0006-Improve-writing-of-data-string-and-unicode-nodes.patch
  C0007-Improve-writing-of-offset-table.patch
- Renamed 0001-Prevent-OOB-heap-buffer-read-by-checking-input-size.patch to
  0012-Prevent-OOB-heap-buffer-read-by-checking-input-size.patch to integrate
  the patch in the list of patches sorted by date.
- In particular, 0011-Disallow-key-nodes-with-non-string-node-types.patch
  fixes a type inconsistency by which a maliciously crafted file could
  cause the application to crash (bsc#1023807, CVE-2017-5836).
- 0014-Check-for-invalid-offset_size-in-bplist-trailer.patch fixes a
  vulnerability by which a maliciously crafted file could cause libplist
  to allocate large amounts of memory and consume lots of CPU
  (bsc#1023822, CVE-2017-5835).
- 0017-Fix-possible-out-of-bounds-read-in-parse_array_node-with-proper-bounds-checking.patch
  fixes a vulnerability by which a maliciously crafted file could cause
  a heap buffer overflow and a segmentation fault (bsc#1023848,
  CVE-2017-5834)
- Dropped CVE-2017-5209 and added
  B0005-base64-Prevent-buffer-overflow-by-not-decoding-blocks-with-less-than-4-chrs.patch
  B0006-Prevent-use-strlen-in-base64decode-when-input-buffer-size-is-known.patch
  B0007-base64-Rework-base64decode-to-handle-split-encoded-data.patch
  to replace the former. These patches fix the same CVE issue in the
  same way but they retain the information of the commits from upstream
  that fix it and add another check for a pointer to be inside bounds
  (boo#1019531, CVE-2017-5209)
* Tue Jan 31 2017 alarrosa@suse.com
- Add 0001-Prevent-OOB-heap-buffer-read-by-checking-input-size.patch
  This patch (from upstream, rebased) prevents an OOB heap buffer
  read which could allow attackers to obtain sensitive information
  from process memory or cause a DoS (bsc#1021610, CVE-2017-5545).
* Wed Jan 25 2017 i@marguerite.su
- Fixed CVE-2017-5209 and boo#1019531: The base64decode function
  in base64.c allows attackers to obtaiin sensitive info from
  process memory or cause a denial of service (buffer over-read)
  via split encoded Apple Property List data.
- Added patch CVE-2017-5209.patch
  * Rework base64decode to handle spliti encoded data correctly
  * The credit goes to Nikias Bassen <nikias@gmx.li>, here's just
    a backport of the upstream commit
* Tue Oct 21 2014 m.szulecki@libimobiledevice.org
- Enable %%check as it is provided by libplist and improves quality
* Fri Oct 17 2014 m.szulecki@libimobiledevice.org
- Update to version 1.12
  * Fix plist_from_bin() changing value nodes to key nodes in dictionaries
  * Avoid exporting non-public symbols
  * Prevent crash in plist_from_bin() when parsing unusual binary plists
  * Fix crash in String|Key::GetValue() and actually make C++ interface work
  * Fix memory leaks in new_xml_plist() and parse_real_node()
  * Fix header guards to conform to C++ standard
  * Update Cython based Python bindings and remove plist_new_key()
  * Fix key nodes not being output correctly if they contained XML entities
  * Fix handling and storage of signed vs. unsigned integer values
  * Fix date handling to respect the "Mac Epoch" instead of "Unix Epoch"
  * Remove plist_set_type() as it should not be used
  * Fix deprecated macros to work with older LLVM/Clang
  * Fix various shadowed declarations
  * Add documentation to explicitly describe memory buffer ownership
  * Fix memory leak in plist_from_bin()
  * Add various test cases based on fixes
  * Fix wrong timezone related date/time conversion of date nodes
  * Fix endian detection on MIPS architecture
  * Fix parallel build for autotools
* Mon Jun 16 2014 i@marguerite.su
- update version 1.11
  * Deprecated plist_dict_insert_item() in favor of plist_dict_set_item()
  * Updated cython bindings for Python 3.x
  * Removed swig python bindings
  * Changed build system to autotools
  * Added new plist_dict_merge() function
  * WIN32 (MinGW) + OSX compilation fixes
  * Made base64 decoding thread safe
- remove patch: libplist-1.8-pkgconfig.patch
  * upstream fixed
- added plist.pxd, needed by python-imobiledevice build
* Mon Apr 15 2013 mmeister@suse.com
- Added url as source.
  Please see http://en.opensuse.org/SourceUrls
* Tue Aug 28 2012 cfarrell@suse.com
- license update: LGPL-2.1+
  LGPL-2.1 can be relicensed to GPL without further permission. No need to
  explicitly call out the GPL as a license option. Fedora has been using
  LGPL-2.1+ for awhile so gain compatibility there too
* Mon Apr  9 2012 opensuse@sukimashita.com
- Allow compilation on 11.4 by disabling cython bindings
* Mon Apr  2 2012 opensuse@sukimashita.com
- Update to version 1.8
  * Add Cython based Python bindings
  * Fix memory corruption in libcnary
  * Fix building on Big Endian systems
  * Removed glib dependency, libplist now uses bundled libcnary
  * Fix building of Python bindings with GCC 4.6
- Do not build SWIG bindings for Python
- Remove gcc46_build_fix.patch due to upstream fixes
- Update pkgconfig patch
* Tue Jan 31 2012 jengelh@medozas.de
- Remove redundant tags/sections per specfile guideline suggestions
- Parallel building using %%_smp_mflags
* Wed Oct  5 2011 uli@suse.com
- cross-build fix: set cmake root, python paths
- cross-build workaround: move installed files from sysroot to
  real root
* Tue Jun 28 2011 aj@suse.de
- Add baselibs.conf - needed by usbmuxd's baselibs.conf.
* Mon May 16 2011 cgiboudeaux@gmx.com
- Add gcc46_build_fix.patch. Fixes build with GCC4.6
* Sun Mar 20 2011 opensuse@sukimashita.com
- Update to version 1.4
  * New maintainer and source location
  * Update AUTHORS from git history
  * Fix Unicode writing in binary plists
  * Update plist doctype
  * Fix Dictionary copy constructor
  * Fix Mac OS X library install path detection
  * Plug memory leak when writing Unicode data
- Remove pkgconfig patch due to upstream fixes
* Wed Dec  8 2010 cristian.rodriguez@opensuse.org
- Fix both -devel package dependencies and broken pkgconfig file
* Tue Apr 27 2010 opensuse@sukimashita.com
- Update to version 1.3
  * Endianness, alignment and type-punning fixes
  * Fix armel floating point endianess
  * Allow compiling with mingw on Windows
  * Minor bugfixes
* Wed Mar 31 2010 vuntz@opensuse.org
- Clean up packaging, based on what I did in multimedia:libs.
* Thu Mar 25 2010 meissner@suse.de
- run prepare_spec
* Thu Jan 21 2010 opensuse@sukimashita.com
- Update to version 1.2
  * Fix xml entity conversion
  * Silence build warnings
- Remove upstreamed patches
* Sat Jan  9 2010 opensuse@sukimashita.com
- Add patches to fix xml entity conversion and tests
* Wed Dec 30 2009 opensuse@sukimashita.com
- Update to version 1.1
  * Fix use of integer nodes within Python Bindings
* Mon Dec  7 2009 opensuse@sukimashita.com
- Update to version 1.0
  * Bugfixes
  * Remove deprecated API
* Wed Oct 28 2009 opensuse@sukimashita.com
- Update to version 0.16
  * Build fixes
  * Fix issues with SWIG
* Sat Oct 24 2009 opensuse@sukimashita.com
- Update to version 0.15
  * Build fixes
- Update to version 0.14
  * Add C++ binding
  * Refactor API
  * Bugfixes
* Sat Jul 18 2009 opensuse@sukimashita.com
- Update to version 0.13
  * Add plist_copy for deep node copies
  * Add node setter functions
  * Unlink nodes from parent if free'd
  * Update Python bindings
* Tue May  5 2009 opensuse@sukimashita.com
- Update to version 0.12
  * Merge ascii and unicode handling in PLIST_STRING using UTF-8
  * Remove unicode related declaration in API (breaks API&ABI)
  * Fix bad variable type for date elements
  * Silence compiler warnings
  * Plugged few memory leaks
* Tue Apr 21 2009 opensuse@sukimashita.com
- Update to version 0.11
  * Fix Python binding segfaults
  * Python API additions
  * Better binary buffer handling in Python bindings
* Sun Apr 12 2009 opensuse@sukimashita.com
- Update to version 0.10
* Tue Apr  7 2009 opensuse@sukimashita.com
- Add patch to fix uninitialized buffer
* Sat Apr  4 2009 opensuse@sukimashita.com
- Initial package created
